#ifndef BIM_ENGINE_RENDERER_H
#define BIM_ENGINE_RENDERER_H

#include "GLEW\glew.h"
#include "glm\glm.hpp"
#include <vector>
#include "ShaderProgram.h"

class Renderer
{
protected:
	int												m_screen_width, m_screen_height;
	
	GLuint m_vao, m_vbo_vertices, m_vbo_colors, m_number_of_vertices;

	float m_continous_time;

	// Protected Functions
	bool InitRenderingTechniques();
	bool InitCommonItems();

	ShaderProgram								m_program;

public:
	Renderer();
	~Renderer();
	bool										Init(int SCREEN_WIDTH, int SCREEN_HEIGHT);
	void										Update(float dt);
	bool										ResizeBuffers(int SCREEN_WIDTH, int SCREEN_HEIGHT);
	bool										ReloadShaders();
	void										Render();

	// Passes
	void										RenderGeometry();

	// set functions

	//get techniques
	
	// Get Functions

};

#endif
